# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class AllocatedLimit(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'configured': 'str',
        'percentage_used': 'str',
        'plan_limit': 'str',
        'used': 'str'
    }

    attribute_map = {
        'configured': 'configured',
        'percentage_used': 'percentage_used',
        'plan_limit': 'plan_limit',
        'used': 'used'
    }

    def __init__(self, configured=None, percentage_used=None, plan_limit=None, used=None, _configuration=None):  # noqa: E501
        """AllocatedLimit - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._configured = None
        self._percentage_used = None
        self._plan_limit = None
        self._used = None
        self.discriminator = None

        if configured is not None:
            self.configured = configured
        if percentage_used is not None:
            self.percentage_used = percentage_used
        if plan_limit is not None:
            self.plan_limit = plan_limit
        if used is not None:
            self.used = used

    @property
    def configured(self):
        """Gets the configured of this AllocatedLimit.


        :return: The configured of this AllocatedLimit.
        :rtype: str
        """
        return self._configured

    @configured.setter
    def configured(self, configured):
        """Sets the configured of this AllocatedLimit.


        :param configured: The configured of this AllocatedLimit.
        :type: str
        """
        if (self._configuration.client_side_validation and
                configured is not None and len(configured) > 32):
            raise ValueError("Invalid value for `configured`, length must be less than or equal to `32`")  # noqa: E501
        if (self._configuration.client_side_validation and
                configured is not None and len(configured) < 1):
            raise ValueError("Invalid value for `configured`, length must be greater than or equal to `1`")  # noqa: E501

        self._configured = configured

    @property
    def percentage_used(self):
        """Gets the percentage_used of this AllocatedLimit.


        :return: The percentage_used of this AllocatedLimit.
        :rtype: str
        """
        return self._percentage_used

    @percentage_used.setter
    def percentage_used(self, percentage_used):
        """Sets the percentage_used of this AllocatedLimit.


        :param percentage_used: The percentage_used of this AllocatedLimit.
        :type: str
        """
        if (self._configuration.client_side_validation and
                percentage_used is not None and len(percentage_used) > 10):
            raise ValueError("Invalid value for `percentage_used`, length must be less than or equal to `10`")  # noqa: E501
        if (self._configuration.client_side_validation and
                percentage_used is not None and len(percentage_used) < 1):
            raise ValueError("Invalid value for `percentage_used`, length must be greater than or equal to `1`")  # noqa: E501

        self._percentage_used = percentage_used

    @property
    def plan_limit(self):
        """Gets the plan_limit of this AllocatedLimit.


        :return: The plan_limit of this AllocatedLimit.
        :rtype: str
        """
        return self._plan_limit

    @plan_limit.setter
    def plan_limit(self, plan_limit):
        """Sets the plan_limit of this AllocatedLimit.


        :param plan_limit: The plan_limit of this AllocatedLimit.
        :type: str
        """
        if (self._configuration.client_side_validation and
                plan_limit is not None and len(plan_limit) > 32):
            raise ValueError("Invalid value for `plan_limit`, length must be less than or equal to `32`")  # noqa: E501
        if (self._configuration.client_side_validation and
                plan_limit is not None and len(plan_limit) < 1):
            raise ValueError("Invalid value for `plan_limit`, length must be greater than or equal to `1`")  # noqa: E501

        self._plan_limit = plan_limit

    @property
    def used(self):
        """Gets the used of this AllocatedLimit.


        :return: The used of this AllocatedLimit.
        :rtype: str
        """
        return self._used

    @used.setter
    def used(self, used):
        """Sets the used of this AllocatedLimit.


        :param used: The used of this AllocatedLimit.
        :type: str
        """
        if (self._configuration.client_side_validation and
                used is not None and len(used) > 32):
            raise ValueError("Invalid value for `used`, length must be less than or equal to `32`")  # noqa: E501
        if (self._configuration.client_side_validation and
                used is not None and len(used) < 1):
            raise ValueError("Invalid value for `used`, length must be greater than or equal to `1`")  # noqa: E501

        self._used = used

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AllocatedLimit, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllocatedLimit):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AllocatedLimit):
            return True

        return self.to_dict() != other.to_dict()

