# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class CommonBandwidthMetricsValue(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'display': 'str',
        'units': 'str',
        'value': 'int'
    }

    attribute_map = {
        'display': 'display',
        'units': 'units',
        'value': 'value'
    }

    def __init__(self, display=None, units='bytes', value=None, _configuration=None):  # noqa: E501
        """CommonBandwidthMetricsValue - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._display = None
        self._units = None
        self._value = None
        self.discriminator = None

        self.display = display
        if units is not None:
            self.units = units
        self.value = value

    @property
    def display(self):
        """Gets the display of this CommonBandwidthMetricsValue.

        Bandwidth usage value

        :return: The display of this CommonBandwidthMetricsValue.
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this CommonBandwidthMetricsValue.

        Bandwidth usage value

        :param display: The display of this CommonBandwidthMetricsValue.
        :type: str
        """
        if self._configuration.client_side_validation and display is None:
            raise ValueError("Invalid value for `display`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                display is not None and len(display) > 64):
            raise ValueError("Invalid value for `display`, length must be less than or equal to `64`")  # noqa: E501
        if (self._configuration.client_side_validation and
                display is not None and len(display) < 1):
            raise ValueError("Invalid value for `display`, length must be greater than or equal to `1`")  # noqa: E501

        self._display = display

    @property
    def units(self):
        """Gets the units of this CommonBandwidthMetricsValue.

        Unit of measurement e.g. bytes

        :return: The units of this CommonBandwidthMetricsValue.
        :rtype: str
        """
        return self._units

    @units.setter
    def units(self, units):
        """Sets the units of this CommonBandwidthMetricsValue.

        Unit of measurement e.g. bytes

        :param units: The units of this CommonBandwidthMetricsValue.
        :type: str
        """
        if (self._configuration.client_side_validation and
                units is not None and len(units) < 1):
            raise ValueError("Invalid value for `units`, length must be greater than or equal to `1`")  # noqa: E501

        self._units = units

    @property
    def value(self):
        """Gets the value of this CommonBandwidthMetricsValue.

        Human readable version of display value

        :return: The value of this CommonBandwidthMetricsValue.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this CommonBandwidthMetricsValue.

        Human readable version of display value

        :param value: The value of this CommonBandwidthMetricsValue.
        :type: int
        """
        if self._configuration.client_side_validation and value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CommonBandwidthMetricsValue, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CommonBandwidthMetricsValue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CommonBandwidthMetricsValue):
            return True

        return self.to_dict() != other.to_dict()

