# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class ConanPackageUploadRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'conan_channel': 'str',
        'conan_prefix': 'str',
        'info_file': 'str',
        'manifest_file': 'str',
        'metadata_file': 'str',
        'name': 'str',
        'package_file': 'str',
        'republish': 'bool',
        'tags': 'str',
        'version': 'str'
    }

    attribute_map = {
        'conan_channel': 'conan_channel',
        'conan_prefix': 'conan_prefix',
        'info_file': 'info_file',
        'manifest_file': 'manifest_file',
        'metadata_file': 'metadata_file',
        'name': 'name',
        'package_file': 'package_file',
        'republish': 'republish',
        'tags': 'tags',
        'version': 'version'
    }

    def __init__(self, conan_channel=None, conan_prefix=None, info_file=None, manifest_file=None, metadata_file=None, name=None, package_file=None, republish=None, tags=None, version=None, _configuration=None):  # noqa: E501
        """ConanPackageUploadRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._conan_channel = None
        self._conan_prefix = None
        self._info_file = None
        self._manifest_file = None
        self._metadata_file = None
        self._name = None
        self._package_file = None
        self._republish = None
        self._tags = None
        self._version = None
        self.discriminator = None

        if conan_channel is not None:
            self.conan_channel = conan_channel
        if conan_prefix is not None:
            self.conan_prefix = conan_prefix
        self.info_file = info_file
        self.manifest_file = manifest_file
        self.metadata_file = metadata_file
        if name is not None:
            self.name = name
        self.package_file = package_file
        if republish is not None:
            self.republish = republish
        if tags is not None:
            self.tags = tags
        if version is not None:
            self.version = version

    @property
    def conan_channel(self):
        """Gets the conan_channel of this ConanPackageUploadRequest.

        Conan channel.

        :return: The conan_channel of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._conan_channel

    @conan_channel.setter
    def conan_channel(self, conan_channel):
        """Sets the conan_channel of this ConanPackageUploadRequest.

        Conan channel.

        :param conan_channel: The conan_channel of this ConanPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                conan_channel is not None and len(conan_channel) > 128):
            raise ValueError("Invalid value for `conan_channel`, length must be less than or equal to `128`")  # noqa: E501
        if (self._configuration.client_side_validation and
                conan_channel is not None and len(conan_channel) < 1):
            raise ValueError("Invalid value for `conan_channel`, length must be greater than or equal to `1`")  # noqa: E501

        self._conan_channel = conan_channel

    @property
    def conan_prefix(self):
        """Gets the conan_prefix of this ConanPackageUploadRequest.

        Conan prefix (User).

        :return: The conan_prefix of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._conan_prefix

    @conan_prefix.setter
    def conan_prefix(self, conan_prefix):
        """Sets the conan_prefix of this ConanPackageUploadRequest.

        Conan prefix (User).

        :param conan_prefix: The conan_prefix of this ConanPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                conan_prefix is not None and len(conan_prefix) > 128):
            raise ValueError("Invalid value for `conan_prefix`, length must be less than or equal to `128`")  # noqa: E501
        if (self._configuration.client_side_validation and
                conan_prefix is not None and len(conan_prefix) < 1):
            raise ValueError("Invalid value for `conan_prefix`, length must be greater than or equal to `1`")  # noqa: E501

        self._conan_prefix = conan_prefix

    @property
    def info_file(self):
        """Gets the info_file of this ConanPackageUploadRequest.

        The info file is an python file containing the package metadata.

        :return: The info_file of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._info_file

    @info_file.setter
    def info_file(self, info_file):
        """Sets the info_file of this ConanPackageUploadRequest.

        The info file is an python file containing the package metadata.

        :param info_file: The info_file of this ConanPackageUploadRequest.
        :type: str
        """
        if self._configuration.client_side_validation and info_file is None:
            raise ValueError("Invalid value for `info_file`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                info_file is not None and len(info_file) < 1):
            raise ValueError("Invalid value for `info_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._info_file = info_file

    @property
    def manifest_file(self):
        """Gets the manifest_file of this ConanPackageUploadRequest.

        The info file is an python file containing the package metadata.

        :return: The manifest_file of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._manifest_file

    @manifest_file.setter
    def manifest_file(self, manifest_file):
        """Sets the manifest_file of this ConanPackageUploadRequest.

        The info file is an python file containing the package metadata.

        :param manifest_file: The manifest_file of this ConanPackageUploadRequest.
        :type: str
        """
        if self._configuration.client_side_validation and manifest_file is None:
            raise ValueError("Invalid value for `manifest_file`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                manifest_file is not None and len(manifest_file) < 1):
            raise ValueError("Invalid value for `manifest_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._manifest_file = manifest_file

    @property
    def metadata_file(self):
        """Gets the metadata_file of this ConanPackageUploadRequest.

        The conan file is an python file containing the package metadata.

        :return: The metadata_file of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._metadata_file

    @metadata_file.setter
    def metadata_file(self, metadata_file):
        """Sets the metadata_file of this ConanPackageUploadRequest.

        The conan file is an python file containing the package metadata.

        :param metadata_file: The metadata_file of this ConanPackageUploadRequest.
        :type: str
        """
        if self._configuration.client_side_validation and metadata_file is None:
            raise ValueError("Invalid value for `metadata_file`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                metadata_file is not None and len(metadata_file) < 1):
            raise ValueError("Invalid value for `metadata_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._metadata_file = metadata_file

    @property
    def name(self):
        """Gets the name of this ConanPackageUploadRequest.

        The name of this package.

        :return: The name of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ConanPackageUploadRequest.

        The name of this package.

        :param name: The name of this ConanPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                name is not None and len(name) > 200):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `200`")  # noqa: E501

        self._name = name

    @property
    def package_file(self):
        """Gets the package_file of this ConanPackageUploadRequest.

        The primary file for the package.

        :return: The package_file of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._package_file

    @package_file.setter
    def package_file(self, package_file):
        """Sets the package_file of this ConanPackageUploadRequest.

        The primary file for the package.

        :param package_file: The package_file of this ConanPackageUploadRequest.
        :type: str
        """
        if self._configuration.client_side_validation and package_file is None:
            raise ValueError("Invalid value for `package_file`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                package_file is not None and len(package_file) < 1):
            raise ValueError("Invalid value for `package_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._package_file = package_file

    @property
    def republish(self):
        """Gets the republish of this ConanPackageUploadRequest.

        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :return: The republish of this ConanPackageUploadRequest.
        :rtype: bool
        """
        return self._republish

    @republish.setter
    def republish(self, republish):
        """Sets the republish of this ConanPackageUploadRequest.

        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :param republish: The republish of this ConanPackageUploadRequest.
        :type: bool
        """

        self._republish = republish

    @property
    def tags(self):
        """Gets the tags of this ConanPackageUploadRequest.

        A comma-separated values list of tags to add to the package.

        :return: The tags of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this ConanPackageUploadRequest.

        A comma-separated values list of tags to add to the package.

        :param tags: The tags of this ConanPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                tags is not None and len(tags) > 1024):
            raise ValueError("Invalid value for `tags`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                tags is not None and len(tags) < 1):
            raise ValueError("Invalid value for `tags`, length must be greater than or equal to `1`")  # noqa: E501

        self._tags = tags

    @property
    def version(self):
        """Gets the version of this ConanPackageUploadRequest.

        The raw version for this package.

        :return: The version of this ConanPackageUploadRequest.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ConanPackageUploadRequest.

        The raw version for this package.

        :param version: The version of this ConanPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                version is not None and len(version) > 128):
            raise ValueError("Invalid value for `version`, length must be less than or equal to `128`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ConanPackageUploadRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConanPackageUploadRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConanPackageUploadRequest):
            return True

        return self.to_dict() != other.to_dict()

