# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class Distribution(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'self_url': 'str',
        'slug': 'str',
        'variants': 'str'
    }

    attribute_map = {
        'name': 'name',
        'self_url': 'self_url',
        'slug': 'slug',
        'variants': 'variants'
    }

    def __init__(self, name=None, self_url=None, slug=None, variants=None, _configuration=None):  # noqa: E501
        """Distribution - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._self_url = None
        self._slug = None
        self._variants = None
        self.discriminator = None

        self.name = name
        if self_url is not None:
            self.self_url = self_url
        if slug is not None:
            self.slug = slug
        if variants is not None:
            self.variants = variants

    @property
    def name(self):
        """Gets the name of this Distribution.


        :return: The name of this Distribution.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Distribution.


        :param name: The name of this Distribution.
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) > 32):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `32`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def self_url(self):
        """Gets the self_url of this Distribution.


        :return: The self_url of this Distribution.
        :rtype: str
        """
        return self._self_url

    @self_url.setter
    def self_url(self, self_url):
        """Sets the self_url of this Distribution.


        :param self_url: The self_url of this Distribution.
        :type: str
        """

        self._self_url = self_url

    @property
    def slug(self):
        """Gets the slug of this Distribution.

        The slug identifier for this distribution

        :return: The slug of this Distribution.
        :rtype: str
        """
        return self._slug

    @slug.setter
    def slug(self, slug):
        """Sets the slug of this Distribution.

        The slug identifier for this distribution

        :param slug: The slug of this Distribution.
        :type: str
        """
        if (self._configuration.client_side_validation and
                slug is not None and len(slug) < 1):
            raise ValueError("Invalid value for `slug`, length must be greater than or equal to `1`")  # noqa: E501

        self._slug = slug

    @property
    def variants(self):
        """Gets the variants of this Distribution.


        :return: The variants of this Distribution.
        :rtype: str
        """
        return self._variants

    @variants.setter
    def variants(self, variants):
        """Sets the variants of this Distribution.


        :param variants: The variants of this Distribution.
        :type: str
        """
        if (self._configuration.client_side_validation and
                variants is not None and len(variants) > 128):
            raise ValueError("Invalid value for `variants`, length must be less than or equal to `128`")  # noqa: E501

        self._variants = variants

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Distribution, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Distribution):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Distribution):
            return True

        return self.to_dict() != other.to_dict()

