# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class History(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'days': 'int',
        'display': 'HistoryFieldset',
        'end': 'datetime',
        'plan': 'str',
        'raw': 'HistoryFieldsetRaw',
        'start': 'datetime'
    }

    attribute_map = {
        'days': 'days',
        'display': 'display',
        'end': 'end',
        'plan': 'plan',
        'raw': 'raw',
        'start': 'start'
    }

    def __init__(self, days=None, display=None, end=None, plan=None, raw=None, start=None, _configuration=None):  # noqa: E501
        """History - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._days = None
        self._display = None
        self._end = None
        self._plan = None
        self._raw = None
        self._start = None
        self.discriminator = None

        if days is not None:
            self.days = days
        self.display = display
        self.end = end
        self.plan = plan
        self.raw = raw
        self.start = start

    @property
    def days(self):
        """Gets the days of this History.


        :return: The days of this History.
        :rtype: int
        """
        return self._days

    @days.setter
    def days(self, days):
        """Sets the days of this History.


        :param days: The days of this History.
        :type: int
        """

        self._days = days

    @property
    def display(self):
        """Gets the display of this History.


        :return: The display of this History.
        :rtype: HistoryFieldset
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this History.


        :param display: The display of this History.
        :type: HistoryFieldset
        """
        if self._configuration.client_side_validation and display is None:
            raise ValueError("Invalid value for `display`, must not be `None`")  # noqa: E501

        self._display = display

    @property
    def end(self):
        """Gets the end of this History.


        :return: The end of this History.
        :rtype: datetime
        """
        return self._end

    @end.setter
    def end(self, end):
        """Sets the end of this History.


        :param end: The end of this History.
        :type: datetime
        """
        if self._configuration.client_side_validation and end is None:
            raise ValueError("Invalid value for `end`, must not be `None`")  # noqa: E501

        self._end = end

    @property
    def plan(self):
        """Gets the plan of this History.


        :return: The plan of this History.
        :rtype: str
        """
        return self._plan

    @plan.setter
    def plan(self, plan):
        """Sets the plan of this History.


        :param plan: The plan of this History.
        :type: str
        """
        if self._configuration.client_side_validation and plan is None:
            raise ValueError("Invalid value for `plan`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                plan is not None and len(plan) > 64):
            raise ValueError("Invalid value for `plan`, length must be less than or equal to `64`")  # noqa: E501
        if (self._configuration.client_side_validation and
                plan is not None and len(plan) < 1):
            raise ValueError("Invalid value for `plan`, length must be greater than or equal to `1`")  # noqa: E501

        self._plan = plan

    @property
    def raw(self):
        """Gets the raw of this History.


        :return: The raw of this History.
        :rtype: HistoryFieldsetRaw
        """
        return self._raw

    @raw.setter
    def raw(self, raw):
        """Sets the raw of this History.


        :param raw: The raw of this History.
        :type: HistoryFieldsetRaw
        """
        if self._configuration.client_side_validation and raw is None:
            raise ValueError("Invalid value for `raw`, must not be `None`")  # noqa: E501

        self._raw = raw

    @property
    def start(self):
        """Gets the start of this History.


        :return: The start of this History.
        :rtype: datetime
        """
        return self._start

    @start.setter
    def start(self, start):
        """Sets the start of this History.


        :param start: The start of this History.
        :type: datetime
        """
        if self._configuration.client_side_validation and start is None:
            raise ValueError("Invalid value for `start`, must not be `None`")  # noqa: E501

        self._start = start

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(History, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, History):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, History):
            return True

        return self.to_dict() != other.to_dict()

