# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class MavenPackageUploadRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'artifact_id': 'str',
        'group_id': 'str',
        'ivy_file': 'str',
        'javadoc_file': 'str',
        'package_file': 'str',
        'packaging': 'str',
        'pom_file': 'str',
        'republish': 'bool',
        'sbt_version': 'str',
        'scala_version': 'str',
        'sources_file': 'str',
        'tags': 'str',
        'tests_file': 'str',
        'version': 'str'
    }

    attribute_map = {
        'artifact_id': 'artifact_id',
        'group_id': 'group_id',
        'ivy_file': 'ivy_file',
        'javadoc_file': 'javadoc_file',
        'package_file': 'package_file',
        'packaging': 'packaging',
        'pom_file': 'pom_file',
        'republish': 'republish',
        'sbt_version': 'sbt_version',
        'scala_version': 'scala_version',
        'sources_file': 'sources_file',
        'tags': 'tags',
        'tests_file': 'tests_file',
        'version': 'version'
    }

    def __init__(self, artifact_id=None, group_id=None, ivy_file=None, javadoc_file=None, package_file=None, packaging=None, pom_file=None, republish=None, sbt_version=None, scala_version=None, sources_file=None, tags=None, tests_file=None, version=None, _configuration=None):  # noqa: E501
        """MavenPackageUploadRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._artifact_id = None
        self._group_id = None
        self._ivy_file = None
        self._javadoc_file = None
        self._package_file = None
        self._packaging = None
        self._pom_file = None
        self._republish = None
        self._sbt_version = None
        self._scala_version = None
        self._sources_file = None
        self._tags = None
        self._tests_file = None
        self._version = None
        self.discriminator = None

        if artifact_id is not None:
            self.artifact_id = artifact_id
        if group_id is not None:
            self.group_id = group_id
        if ivy_file is not None:
            self.ivy_file = ivy_file
        if javadoc_file is not None:
            self.javadoc_file = javadoc_file
        self.package_file = package_file
        if packaging is not None:
            self.packaging = packaging
        if pom_file is not None:
            self.pom_file = pom_file
        if republish is not None:
            self.republish = republish
        if sbt_version is not None:
            self.sbt_version = sbt_version
        if scala_version is not None:
            self.scala_version = scala_version
        if sources_file is not None:
            self.sources_file = sources_file
        if tags is not None:
            self.tags = tags
        if tests_file is not None:
            self.tests_file = tests_file
        if version is not None:
            self.version = version

    @property
    def artifact_id(self):
        """Gets the artifact_id of this MavenPackageUploadRequest.

        The ID of the artifact.

        :return: The artifact_id of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._artifact_id

    @artifact_id.setter
    def artifact_id(self, artifact_id):
        """Sets the artifact_id of this MavenPackageUploadRequest.

        The ID of the artifact.

        :param artifact_id: The artifact_id of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                artifact_id is not None and len(artifact_id) < 1):
            raise ValueError("Invalid value for `artifact_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._artifact_id = artifact_id

    @property
    def group_id(self):
        """Gets the group_id of this MavenPackageUploadRequest.

        Artifact's group ID.

        :return: The group_id of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """Sets the group_id of this MavenPackageUploadRequest.

        Artifact's group ID.

        :param group_id: The group_id of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                group_id is not None and len(group_id) > 2083):
            raise ValueError("Invalid value for `group_id`, length must be less than or equal to `2083`")  # noqa: E501

        self._group_id = group_id

    @property
    def ivy_file(self):
        """Gets the ivy_file of this MavenPackageUploadRequest.

        The ivy file is an XML file describing the dependencies of the project.

        :return: The ivy_file of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._ivy_file

    @ivy_file.setter
    def ivy_file(self, ivy_file):
        """Sets the ivy_file of this MavenPackageUploadRequest.

        The ivy file is an XML file describing the dependencies of the project.

        :param ivy_file: The ivy_file of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                ivy_file is not None and len(ivy_file) < 1):
            raise ValueError("Invalid value for `ivy_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._ivy_file = ivy_file

    @property
    def javadoc_file(self):
        """Gets the javadoc_file of this MavenPackageUploadRequest.

        Adds bundled Java documentation to the Maven package

        :return: The javadoc_file of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._javadoc_file

    @javadoc_file.setter
    def javadoc_file(self, javadoc_file):
        """Sets the javadoc_file of this MavenPackageUploadRequest.

        Adds bundled Java documentation to the Maven package

        :param javadoc_file: The javadoc_file of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                javadoc_file is not None and len(javadoc_file) < 1):
            raise ValueError("Invalid value for `javadoc_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._javadoc_file = javadoc_file

    @property
    def package_file(self):
        """Gets the package_file of this MavenPackageUploadRequest.

        The primary file for the package.

        :return: The package_file of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._package_file

    @package_file.setter
    def package_file(self, package_file):
        """Sets the package_file of this MavenPackageUploadRequest.

        The primary file for the package.

        :param package_file: The package_file of this MavenPackageUploadRequest.
        :type: str
        """
        if self._configuration.client_side_validation and package_file is None:
            raise ValueError("Invalid value for `package_file`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                package_file is not None and len(package_file) < 1):
            raise ValueError("Invalid value for `package_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._package_file = package_file

    @property
    def packaging(self):
        """Gets the packaging of this MavenPackageUploadRequest.

        Artifact's Maven packaging type.

        :return: The packaging of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._packaging

    @packaging.setter
    def packaging(self, packaging):
        """Sets the packaging of this MavenPackageUploadRequest.

        Artifact's Maven packaging type.

        :param packaging: The packaging of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                packaging is not None and len(packaging) > 64):
            raise ValueError("Invalid value for `packaging`, length must be less than or equal to `64`")  # noqa: E501

        self._packaging = packaging

    @property
    def pom_file(self):
        """Gets the pom_file of this MavenPackageUploadRequest.

        The POM file is an XML file containing the Maven coordinates.

        :return: The pom_file of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._pom_file

    @pom_file.setter
    def pom_file(self, pom_file):
        """Sets the pom_file of this MavenPackageUploadRequest.

        The POM file is an XML file containing the Maven coordinates.

        :param pom_file: The pom_file of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                pom_file is not None and len(pom_file) < 1):
            raise ValueError("Invalid value for `pom_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._pom_file = pom_file

    @property
    def republish(self):
        """Gets the republish of this MavenPackageUploadRequest.

        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :return: The republish of this MavenPackageUploadRequest.
        :rtype: bool
        """
        return self._republish

    @republish.setter
    def republish(self, republish):
        """Sets the republish of this MavenPackageUploadRequest.

        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :param republish: The republish of this MavenPackageUploadRequest.
        :type: bool
        """

        self._republish = republish

    @property
    def sbt_version(self):
        """Gets the sbt_version of this MavenPackageUploadRequest.


        :return: The sbt_version of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._sbt_version

    @sbt_version.setter
    def sbt_version(self, sbt_version):
        """Sets the sbt_version of this MavenPackageUploadRequest.


        :param sbt_version: The sbt_version of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                sbt_version is not None and len(sbt_version) > 64):
            raise ValueError("Invalid value for `sbt_version`, length must be less than or equal to `64`")  # noqa: E501

        self._sbt_version = sbt_version

    @property
    def scala_version(self):
        """Gets the scala_version of this MavenPackageUploadRequest.


        :return: The scala_version of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._scala_version

    @scala_version.setter
    def scala_version(self, scala_version):
        """Sets the scala_version of this MavenPackageUploadRequest.


        :param scala_version: The scala_version of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                scala_version is not None and len(scala_version) > 64):
            raise ValueError("Invalid value for `scala_version`, length must be less than or equal to `64`")  # noqa: E501

        self._scala_version = scala_version

    @property
    def sources_file(self):
        """Gets the sources_file of this MavenPackageUploadRequest.

        Adds bundled Java source code to the Maven package.

        :return: The sources_file of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._sources_file

    @sources_file.setter
    def sources_file(self, sources_file):
        """Sets the sources_file of this MavenPackageUploadRequest.

        Adds bundled Java source code to the Maven package.

        :param sources_file: The sources_file of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                sources_file is not None and len(sources_file) < 1):
            raise ValueError("Invalid value for `sources_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._sources_file = sources_file

    @property
    def tags(self):
        """Gets the tags of this MavenPackageUploadRequest.

        A comma-separated values list of tags to add to the package.

        :return: The tags of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this MavenPackageUploadRequest.

        A comma-separated values list of tags to add to the package.

        :param tags: The tags of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                tags is not None and len(tags) > 1024):
            raise ValueError("Invalid value for `tags`, length must be less than or equal to `1024`")  # noqa: E501
        if (self._configuration.client_side_validation and
                tags is not None and len(tags) < 1):
            raise ValueError("Invalid value for `tags`, length must be greater than or equal to `1`")  # noqa: E501

        self._tags = tags

    @property
    def tests_file(self):
        """Gets the tests_file of this MavenPackageUploadRequest.

        Adds bundled Java tests to the Maven package.

        :return: The tests_file of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._tests_file

    @tests_file.setter
    def tests_file(self, tests_file):
        """Sets the tests_file of this MavenPackageUploadRequest.

        Adds bundled Java tests to the Maven package.

        :param tests_file: The tests_file of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                tests_file is not None and len(tests_file) < 1):
            raise ValueError("Invalid value for `tests_file`, length must be greater than or equal to `1`")  # noqa: E501

        self._tests_file = tests_file

    @property
    def version(self):
        """Gets the version of this MavenPackageUploadRequest.

        The raw version for this package.

        :return: The version of this MavenPackageUploadRequest.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this MavenPackageUploadRequest.

        The raw version for this package.

        :param version: The version of this MavenPackageUploadRequest.
        :type: str
        """
        if (self._configuration.client_side_validation and
                version is not None and len(version) > 128):
            raise ValueError("Invalid value for `version`, length must be less than or equal to `128`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MavenPackageUploadRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MavenPackageUploadRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MavenPackageUploadRequest):
            return True

        return self.to_dict() != other.to_dict()

