# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class Organization(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'country': 'str',
        'created_at': 'datetime',
        'location': 'str',
        'name': 'str',
        'slug': 'str',
        'slug_perm': 'str',
        'tagline': 'str'
    }

    attribute_map = {
        'country': 'country',
        'created_at': 'created_at',
        'location': 'location',
        'name': 'name',
        'slug': 'slug',
        'slug_perm': 'slug_perm',
        'tagline': 'tagline'
    }

    def __init__(self, country=None, created_at=None, location=None, name=None, slug=None, slug_perm=None, tagline=None, _configuration=None):  # noqa: E501
        """Organization - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._country = None
        self._created_at = None
        self._location = None
        self._name = None
        self._slug = None
        self._slug_perm = None
        self._tagline = None
        self.discriminator = None

        if country is not None:
            self.country = country
        if created_at is not None:
            self.created_at = created_at
        if location is not None:
            self.location = location
        self.name = name
        if slug is not None:
            self.slug = slug
        if slug_perm is not None:
            self.slug_perm = slug_perm
        if tagline is not None:
            self.tagline = tagline

    @property
    def country(self):
        """Gets the country of this Organization.


        :return: The country of this Organization.
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this Organization.


        :param country: The country of this Organization.
        :type: str
        """
        if (self._configuration.client_side_validation and
                country is not None and len(country) > 32):
            raise ValueError("Invalid value for `country`, length must be less than or equal to `32`")  # noqa: E501
        if (self._configuration.client_side_validation and
                country is not None and len(country) < 1):
            raise ValueError("Invalid value for `country`, length must be greater than or equal to `1`")  # noqa: E501

        self._country = country

    @property
    def created_at(self):
        """Gets the created_at of this Organization.


        :return: The created_at of this Organization.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Organization.


        :param created_at: The created_at of this Organization.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def location(self):
        """Gets the location of this Organization.

        The city/town/area your organization is based in.

        :return: The location of this Organization.
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Organization.

        The city/town/area your organization is based in.

        :param location: The location of this Organization.
        :type: str
        """

        self._location = location

    @property
    def name(self):
        """Gets the name of this Organization.


        :return: The name of this Organization.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Organization.


        :param name: The name of this Organization.
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def slug(self):
        """Gets the slug of this Organization.


        :return: The slug of this Organization.
        :rtype: str
        """
        return self._slug

    @slug.setter
    def slug(self, slug):
        """Sets the slug of this Organization.


        :param slug: The slug of this Organization.
        :type: str
        """

        self._slug = slug

    @property
    def slug_perm(self):
        """Gets the slug_perm of this Organization.


        :return: The slug_perm of this Organization.
        :rtype: str
        """
        return self._slug_perm

    @slug_perm.setter
    def slug_perm(self, slug_perm):
        """Sets the slug_perm of this Organization.


        :param slug_perm: The slug_perm of this Organization.
        :type: str
        """

        self._slug_perm = slug_perm

    @property
    def tagline(self):
        """Gets the tagline of this Organization.

        A short public descriptive for your organization.

        :return: The tagline of this Organization.
        :rtype: str
        """
        return self._tagline

    @tagline.setter
    def tagline(self, tagline):
        """Sets the tagline of this Organization.

        A short public descriptive for your organization.

        :param tagline: The tagline of this Organization.
        :type: str
        """

        self._tagline = tagline

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Organization, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Organization):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Organization):
            return True

        return self.to_dict() != other.to_dict()

