# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class PackageDependency(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dep_type': 'str',
        'name': 'str',
        'operator': 'str',
        'version': 'str'
    }

    attribute_map = {
        'dep_type': 'dep_type',
        'name': 'name',
        'operator': 'operator',
        'version': 'version'
    }

    def __init__(self, dep_type='Depends', name=None, operator='=', version=None, _configuration=None):  # noqa: E501
        """PackageDependency - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._dep_type = None
        self._name = None
        self._operator = None
        self._version = None
        self.discriminator = None

        if dep_type is not None:
            self.dep_type = dep_type
        self.name = name
        if operator is not None:
            self.operator = operator
        if version is not None:
            self.version = version

    @property
    def dep_type(self):
        """Gets the dep_type of this PackageDependency.


        :return: The dep_type of this PackageDependency.
        :rtype: str
        """
        return self._dep_type

    @dep_type.setter
    def dep_type(self, dep_type):
        """Sets the dep_type of this PackageDependency.


        :param dep_type: The dep_type of this PackageDependency.
        :type: str
        """
        allowed_values = ["Depends", "Pre-Depends", "Recommends", "Suggests", "Enhances", "Replaces", "Breaks", "Built-Using", "Build-Depends", "Build-Depends-Indep", "Build-Conflicts", "Build-Conflicts-Indep", "Conflicts", "Provides", "Obsoletes", "Requires", "Runtime", "Development", "Compile", "Provided", "Test", "System", "Import", "Excluded", "Build-Requires", "Python-Requires"]  # noqa: E501
        if (self._configuration.client_side_validation and
                dep_type not in allowed_values):
            raise ValueError(
                "Invalid value for `dep_type` ({0}), must be one of {1}"  # noqa: E501
                .format(dep_type, allowed_values)
            )

        self._dep_type = dep_type

    @property
    def name(self):
        """Gets the name of this PackageDependency.

        The name of the package dependency.

        :return: The name of this PackageDependency.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PackageDependency.

        The name of the package dependency.

        :param name: The name of this PackageDependency.
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) > 255):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `255`")  # noqa: E501
        if (self._configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def operator(self):
        """Gets the operator of this PackageDependency.


        :return: The operator of this PackageDependency.
        :rtype: str
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this PackageDependency.


        :param operator: The operator of this PackageDependency.
        :type: str
        """
        allowed_values = ["=", "!=", "<", "<<", "<=", ">", ">>", ">=", "~=", "~>", "matches"]  # noqa: E501
        if (self._configuration.client_side_validation and
                operator not in allowed_values):
            raise ValueError(
                "Invalid value for `operator` ({0}), must be one of {1}"  # noqa: E501
                .format(operator, allowed_values)
            )

        self._operator = operator

    @property
    def version(self):
        """Gets the version of this PackageDependency.

        The raw dependency version (if any).

        :return: The version of this PackageDependency.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PackageDependency.

        The raw dependency version (if any).

        :param version: The version of this PackageDependency.
        :type: str
        """
        if (self._configuration.client_side_validation and
                version is not None and len(version) > 128):
            raise ValueError("Invalid value for `version`, length must be less than or equal to `128`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PackageDependency, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PackageDependency):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PackageDependency):
            return True

        return self.to_dict() != other.to_dict()

