# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class RepositoryGpgKeyCreate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'gpg_passphrase': 'str',
        'gpg_private_key': 'str'
    }

    attribute_map = {
        'gpg_passphrase': 'gpg_passphrase',
        'gpg_private_key': 'gpg_private_key'
    }

    def __init__(self, gpg_passphrase=None, gpg_private_key=None, _configuration=None):  # noqa: E501
        """RepositoryGpgKeyCreate - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._gpg_passphrase = None
        self._gpg_private_key = None
        self.discriminator = None

        if gpg_passphrase is not None:
            self.gpg_passphrase = gpg_passphrase
        self.gpg_private_key = gpg_private_key

    @property
    def gpg_passphrase(self):
        """Gets the gpg_passphrase of this RepositoryGpgKeyCreate.

        The GPG passphrase used for signing.

        :return: The gpg_passphrase of this RepositoryGpgKeyCreate.
        :rtype: str
        """
        return self._gpg_passphrase

    @gpg_passphrase.setter
    def gpg_passphrase(self, gpg_passphrase):
        """Sets the gpg_passphrase of this RepositoryGpgKeyCreate.

        The GPG passphrase used for signing.

        :param gpg_passphrase: The gpg_passphrase of this RepositoryGpgKeyCreate.
        :type: str
        """
        if (self._configuration.client_side_validation and
                gpg_passphrase is not None and len(gpg_passphrase) < 1):
            raise ValueError("Invalid value for `gpg_passphrase`, length must be greater than or equal to `1`")  # noqa: E501

        self._gpg_passphrase = gpg_passphrase

    @property
    def gpg_private_key(self):
        """Gets the gpg_private_key of this RepositoryGpgKeyCreate.

        The GPG private key.

        :return: The gpg_private_key of this RepositoryGpgKeyCreate.
        :rtype: str
        """
        return self._gpg_private_key

    @gpg_private_key.setter
    def gpg_private_key(self, gpg_private_key):
        """Sets the gpg_private_key of this RepositoryGpgKeyCreate.

        The GPG private key.

        :param gpg_private_key: The gpg_private_key of this RepositoryGpgKeyCreate.
        :type: str
        """
        if self._configuration.client_side_validation and gpg_private_key is None:
            raise ValueError("Invalid value for `gpg_private_key`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                gpg_private_key is not None and len(gpg_private_key) < 1):
            raise ValueError("Invalid value for `gpg_private_key`, length must be greater than or equal to `1`")  # noqa: E501

        self._gpg_private_key = gpg_private_key

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RepositoryGpgKeyCreate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RepositoryGpgKeyCreate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RepositoryGpgKeyCreate):
            return True

        return self.to_dict() != other.to_dict()

