# coding: utf-8

"""
    Cloudsmith API (v1)

    The API to the Cloudsmith Service  # noqa: E501

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cloudsmith_api.configuration import Configuration


class PackageVulnerability(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'identifier': 'str',
        'name': 'str',
        'url': 'str',
        'version': 'str'
    }

    attribute_map = {
        'identifier': 'identifier',
        'name': 'name',
        'url': 'url',
        'version': 'version'
    }

    def __init__(self, identifier=None, name=None, url=None, version=None, _configuration=None):  # noqa: E501
        """PackageVulnerability - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._identifier = None
        self._name = None
        self._url = None
        self._version = None
        self.discriminator = None

        self.identifier = identifier
        if name is not None:
            self.name = name
        if url is not None:
            self.url = url
        if version is not None:
            self.version = version

    @property
    def identifier(self):
        """Gets the identifier of this PackageVulnerability.


        :return: The identifier of this PackageVulnerability.
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this PackageVulnerability.


        :param identifier: The identifier of this PackageVulnerability.
        :type: str
        """
        if self._configuration.client_side_validation and identifier is None:
            raise ValueError("Invalid value for `identifier`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                identifier is not None and len(identifier) < 1):
            raise ValueError("Invalid value for `identifier`, length must be greater than or equal to `1`")  # noqa: E501

        self._identifier = identifier

    @property
    def name(self):
        """Gets the name of this PackageVulnerability.

        The name of this package.

        :return: The name of this PackageVulnerability.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PackageVulnerability.

        The name of this package.

        :param name: The name of this PackageVulnerability.
        :type: str
        """

        self._name = name

    @property
    def url(self):
        """Gets the url of this PackageVulnerability.


        :return: The url of this PackageVulnerability.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this PackageVulnerability.


        :param url: The url of this PackageVulnerability.
        :type: str
        """

        self._url = url

    @property
    def version(self):
        """Gets the version of this PackageVulnerability.

        The raw version for this package.

        :return: The version of this PackageVulnerability.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PackageVulnerability.

        The raw version for this package.

        :param version: The version of this PackageVulnerability.
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PackageVulnerability, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PackageVulnerability):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PackageVulnerability):
            return True

        return self.to_dict() != other.to_dict()

